<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<script>
    $(document).ready(function () {
        onPageLoading()

        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gNameCol = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
        const gCOL_USER_ID = 0;
        const gCOL_FIRST_NAME = 1;
        const gCOL_LAST_NAME = 2;
        const gCOL_COUNTRY = 3;
        const gCOL_SUBJECT = 4;
        const gCOL_CUSTOMER_TYPE = 5;
        const gCOL_REGISTER_STATUS = 6;
        const gCOL_ACTION = 7;

        $("#user-table").DataTable({
            columns: [
                { data: gNameCol[gCOL_USER_ID] },
                { data: gNameCol[gCOL_FIRST_NAME] },
                { data: gNameCol[gCOL_LAST_NAME] },
                { data: gNameCol[gCOL_COUNTRY] },
                { data: gNameCol[gCOL_SUBJECT] },
                { data: gNameCol[gCOL_CUSTOMER_TYPE] },
                { data: gNameCol[gCOL_REGISTER_STATUS] },
                { data: gNameCol[gCOL_ACTION] },
            ],
            columnDefs: [
                {
                    targets: gCOL_ACTION,
                    defaultContent: "<button class = 'btn btn-success btn-detail'>Chi tiết</button>",
                }

            ]
        })


        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading()

        $("#user-table").on("click", ".btn-detail", function () {
            onBtnChiTietClick(this);
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                type: "GET",
                success: function (param) {
                    console.log(param)
                    console.log(Object.entries(param))
                    loaDataToTable(param)
                },
                error: function (paramError) {
                    console.assert(paramError.responseText)
                }

            })
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        function loaDataToTable(paramOjb) {
            var vTable = $("#user-table").DataTable()
            vTable.clear()
            vTable.rows.add(paramOjb)
            vTable.draw()
        }

        function onBtnChiTietClick(paramButton) {
            var vRow = $(paramButton).closest("tr");
            var vTable = $("#user-table").DataTable();
            var DataRow = vTable.row(vRow).data();
            console.log(DataRow)
        }
    })
</script>

<body>
    <div class="container-fluid">
        <div class="text-center mb-4">
            <h3>Danh sách dăng ký</h3>
        </div>
        <table id="user-table" class="table table-hover table-bordered table-striped">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>

                    <th>Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
</body>

</html>